System.registerDynamic("src/goo-map/goo-map.component", ["@angular/core", "../service/goo-maps-api.service"], true, function ($__require, exports, module) {
    "use strict";

    var define,
        global = this || self,
        GLOBAL = global;
    var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
        var c = arguments.length,
            r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
            d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __metadata = this && this.__metadata || function (k, v) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
    };
    var core_1 = $__require("@angular/core");
    var goo_maps_api_service_1 = $__require("../service/goo-maps-api.service");
    var GOO_MAPS_ID = {
        currentId: 1
    };
    var GooMap = function () {
        function GooMap(gooMapsApi) {
            this.gooMapsApi = gooMapsApi;
            this.mapId = 'map_' + GOO_MAPS_ID.currentId++;
        }
        GooMap.prototype.ngOnChanges = function (changes) {
            if (changes['options']) {
                this.gooMapsApi.setMapOptions(this.options);
            }
            if (changes['bounds']) {
                this.gooMapsApi.fitMapBounds(this.bounds);
            }
            if (changes['center']) {
                this.gooMapsApi.setCenter(this.center);
            }
        };
        GooMap.prototype.ngOnInit = function () {
            this.gooMapsApi.init(this.mapId, this.options);
        };
        __decorate([core_1.Input('height'), __metadata('design:type', Number)], GooMap.prototype, "mapHeight", void 0);
        __decorate([core_1.Input('options'), __metadata('design:type', Object)], GooMap.prototype, "options", void 0);
        __decorate([core_1.Input('mapId'), __metadata('design:type', String)], GooMap.prototype, "mapId", void 0);
        __decorate([core_1.Input('bounds'), __metadata('design:type', Object)], GooMap.prototype, "bounds", void 0);
        __decorate([core_1.Input('center'), __metadata('design:type', Object)], GooMap.prototype, "center", void 0);
        __decorate([core_1.Input('styleClass'), __metadata('design:type', String)], GooMap.prototype, "styleClass", void 0);
        GooMap = __decorate([core_1.Component({
            selector: 'goo-map',
            template: '<div class="goo-map {{styleClass}}" id="{{mapId}}" [style.height]="mapHeight?mapHeight + \'px\':\'\'"></div><div id="map-content"><ng-content></ng-content></div>'
        }), __metadata('design:paramtypes', [goo_maps_api_service_1.GooMapsApiService])], GooMap);
        return GooMap;
    }();
    exports.GooMap = GooMap;
    

    return module.exports;
});
System.registerDynamic("src/goo-marker/goo-marker.directive", ["@angular/core", "../service/goo-maps-api.service", "../goo-info-window/goo-info-window.component"], true, function ($__require, exports, module) {
    "use strict";

    var define,
        global = this || self,
        GLOBAL = global;
    var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
        var c = arguments.length,
            r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
            d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __metadata = this && this.__metadata || function (k, v) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
    };
    var core_1 = $__require("@angular/core");
    var goo_maps_api_service_1 = $__require("../service/goo-maps-api.service");
    var goo_info_window_component_1 = $__require("../goo-info-window/goo-info-window.component");
    var GooMarker = function () {
        function GooMarker(gooMapsApi) {
            var _this = this;
            this.gooMapsApi = gooMapsApi;
            this.positionChange = new core_1.EventEmitter();
            var self = this;
            this.position = { lat: 0, lng: 0 };
            this.title = '';
            this.promiseMarker = new Promise(function (resolve) {
                _this.gooMapsApi.buildMarker({
                    position: _this.position,
                    title: _this.title
                }).then(function (marker) {
                    marker.addListener('dragend', function () {
                        self.onPositionChange({ lat: marker.getPosition().lat(), lng: marker.getPosition().lng() });
                    });
                    resolve(marker);
                });
            });
        }
        GooMarker.prototype.ngOnChanges = function (changes) {
            if (changes['draggable']) {
                this.setDraggable(this.draggable);
            }
            if (changes['position']) {
                this.setPosition(this.position);
            }
            if (changes['title']) {
                this.setTitle(this.title);
            }
            if (changes['label']) {
                this.setLabel(this.label);
            }
        };
        GooMarker.prototype.ngOnInit = function () {
            var _this = this;
            this.promiseMarker.then(function (marker) {
                marker.setPosition(_this.position);
                marker.setTitle(_this.title);
                if (_this.infoWindow !== undefined && _this.infoWindow) {
                    _this.infoWindow.setMarker(marker);
                }
            });
        };
        GooMarker.prototype.ngOnDestroy = function () {
            this.promiseMarker.then(function (marker) {
                return marker.setMap(null);
            });
        };
        GooMarker.prototype.onPositionChange = function (position) {
            this.position = position;
            this.positionChange.emit(this.position);
        };
        GooMarker.prototype.setDraggable = function (draggable) {
            this.promiseMarker.then(function (marker) {
                marker.setDraggable(draggable);
            });
        };
        GooMarker.prototype.setPosition = function (position) {
            this.promiseMarker.then(function (marker) {
                marker.setPosition(position);
            });
        };
        GooMarker.prototype.setTitle = function (title) {
            this.promiseMarker.then(function (marker) {
                marker.setTitle(title);
            });
        };
        GooMarker.prototype.setLabel = function (label) {
            this.promiseMarker.then(function (marker) {
                marker.setLabel(label);
            });
        };
        __decorate([core_1.Input(), __metadata('design:type', Object)], GooMarker.prototype, "position", void 0);
        __decorate([core_1.Output(), __metadata('design:type', core_1.EventEmitter)], GooMarker.prototype, "positionChange", void 0);
        __decorate([core_1.Input(), __metadata('design:type', String)], GooMarker.prototype, "title", void 0);
        __decorate([core_1.Input(), __metadata('design:type', Boolean)], GooMarker.prototype, "draggable", void 0);
        __decorate([core_1.Input(), __metadata('design:type', String)], GooMarker.prototype, "label", void 0);
        __decorate([core_1.ContentChild(goo_info_window_component_1.GooInfoWindow), __metadata('design:type', goo_info_window_component_1.GooInfoWindow)], GooMarker.prototype, "infoWindow", void 0);
        GooMarker = __decorate([core_1.Directive({
            selector: 'goo-marker'
        }), __metadata('design:paramtypes', [goo_maps_api_service_1.GooMapsApiService])], GooMarker);
        return GooMarker;
    }();
    exports.GooMarker = GooMarker;
    

    return module.exports;
});
System.registerDynamic("src/goo-rectangle/goo-rectangle.directive", ["@angular/core", "../service/goo-maps-api.service"], true, function ($__require, exports, module) {
    "use strict";

    var define,
        global = this || self,
        GLOBAL = global;
    var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
        var c = arguments.length,
            r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
            d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __metadata = this && this.__metadata || function (k, v) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
    };
    var core_1 = $__require("@angular/core");
    var goo_maps_api_service_1 = $__require("../service/goo-maps-api.service");
    var GooRectangle = function () {
        function GooRectangle(gooMapsApi) {
            var _this = this;
            this.gooMapsApi = gooMapsApi;
            this.boundsChanged = new core_1.EventEmitter();
            this.draggable = false;
            this.editable = false;
            var self = this;
            this.promiseRectangle = new Promise(function (resolve) {
                _this.gooMapsApi.buildRectangle({}).then(function (rectangle) {
                    rectangle.addListener('dragend', function () {
                        var bounds = rectangle.getBounds();
                        self.onBoundsChanged({
                            north: bounds.getNorthEast().lat(),
                            south: bounds.getSouthWest().lat(),
                            east: bounds.getNorthEast().lng(),
                            west: bounds.getSouthWest().lng()
                        });
                    });
                    resolve(rectangle);
                });
            });
        }
        GooRectangle.prototype.ngOnChanges = function (changes) {
            var self = this;
            if (changes['draggable']) {
                this.promiseRectangle.then(function (rectangle) {
                    rectangle.setDraggable(self.draggable ? true : false);
                });
            }
            if (changes['editable']) {
                this.promiseRectangle.then(function (rectangle) {
                    rectangle.setEditable(self.editable ? true : false);
                });
            }
            // if (changes['bounds']) {
            //   this.promiseRectangle.then(function (rectangle) {
            //     rectangle.setBounds(self.bounds);
            //   });
            // } // CAUSES AN EVENT LOOP (TODO)
        };
        GooRectangle.prototype.ngOnInit = function () {
            var _this = this;
            this.promiseRectangle.then(function (rectangle) {
                rectangle.setBounds(_this.bounds);
                rectangle.setDraggable(_this.draggable);
                rectangle.setEditable(_this.editable);
            });
        };
        GooRectangle.prototype.ngOnDestroy = function () {
            this.promiseRectangle.then(function (rectangle) {
                return rectangle.setMap(null);
            });
        };
        GooRectangle.prototype.onBoundsChanged = function (bounds) {
            this.bounds = bounds;
            this.boundsChanged.emit(bounds);
        };
        __decorate([core_1.Input('bounds'), __metadata('design:type', Object)], GooRectangle.prototype, "bounds", void 0);
        __decorate([core_1.Output('boundsChanged'), __metadata('design:type', core_1.EventEmitter)], GooRectangle.prototype, "boundsChanged", void 0);
        __decorate([core_1.Input(), __metadata('design:type', Boolean)], GooRectangle.prototype, "draggable", void 0);
        __decorate([core_1.Input(), __metadata('design:type', Boolean)], GooRectangle.prototype, "editable", void 0);
        GooRectangle = __decorate([core_1.Directive({
            selector: 'goo-rectangle'
        }), __metadata('design:paramtypes', [goo_maps_api_service_1.GooMapsApiService])], GooRectangle);
        return GooRectangle;
    }();
    exports.GooRectangle = GooRectangle;
    

    return module.exports;
});
System.registerDynamic("src/goo-polyline/goo-polyline.directive", ["@angular/core", "../service/goo-maps-api.service"], true, function ($__require, exports, module) {
    "use strict";

    var define,
        global = this || self,
        GLOBAL = global;
    var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
        var c = arguments.length,
            r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
            d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __metadata = this && this.__metadata || function (k, v) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
    };
    var core_1 = $__require("@angular/core");
    var goo_maps_api_service_1 = $__require("../service/goo-maps-api.service");
    var GooPolyline = function () {
        function GooPolyline(gooMapsApi) {
            var _this = this;
            this.gooMapsApi = gooMapsApi;
            this.pathChange = new core_1.EventEmitter();
            this.strokeColor = '#FF0000';
            this.pathChangedCallback = function () {
                _this.promisePolyline.then(function (polyline) {
                    var path = polyline.getPath().getArray();
                    _this.onChangePath(path);
                });
            };
            var self = this;
            this.promisePolyline = new Promise(function (resolve) {
                _this.gooMapsApi.buildPolyline({}).then(function (polyline) {
                    google.maps.event.addListener(polyline, 'rightclick', function (e) {
                        if (e.vertex === undefined) {
                            return;
                        }
                        self.buildDeleteMenu().open(polyline.getMap(), polyline.getPath(), e.vertex);
                    });
                    resolve(polyline);
                });
            });
        }
        GooPolyline.prototype.ngOnChanges = function (changes) {
            if (changes['editable']) {
                this.setEditable(this.editable);
            }
            if (changes['path']) {
                this.setPath(this.path);
            }
            if (changes['strokeColor']) {
                this.setStrokeColor(this.strokeColor);
            }
        };
        GooPolyline.prototype.ngOnInit = function () {
            var _this = this;
            this.promisePolyline.then(function (polyline) {
                polyline.setPath(_this.path);
                polyline.setOptions(_this.options);
            });
        };
        GooPolyline.prototype.ngOnDestroy = function () {
            this.promisePolyline.then(function (polyline) {
                return polyline.setMap(null);
            });
        };
        GooPolyline.prototype.onChangePath = function (event) {
            this.path = event;
            this.pathChange.emit(event);
        };
        GooPolyline.prototype.setEditable = function (editable) {
            this.promisePolyline.then(function (polyline) {
                polyline.setEditable(editable);
            });
        };
        GooPolyline.prototype.setStrokeColor = function (color) {
            this.promisePolyline.then(function (polyline) {
                polyline.setOptions({
                    strokeColor: color
                });
            });
        };
        GooPolyline.prototype.setPath = function (path) {
            var self = this;
            this.promisePolyline.then(function (polyline) {
                polyline.setPath(path);
                google.maps.event.addListener(polyline.getPath(), 'insert_at', self.pathChangedCallback);
                google.maps.event.addListener(polyline.getPath(), 'remove_at', self.pathChangedCallback);
                google.maps.event.addListener(polyline.getPath(), 'set_at', self.pathChangedCallback);
            });
        };
        GooPolyline.prototype.buildDeleteMenu = function () {
            function DeleteMenu() {
                this.div_ = document.createElement('div');
                this.div_.className = 'delete-menu';
                this.div_.innerHTML = 'Delete';
                this.div_.style.cssText = 'position:absolute;background:white;padding:3px;color:#666;font-weight:bold;' + 'border:1pxsolid#999;font-family:sans-serif;font-size:12px;box-shadow:1px3px3pxrgba(0,0,0,.3);' + 'margin-top:-10px;margin-left:10px;cursor:pointer;';
                var menu = this;
                google.maps.event.addDomListener(this.div_, 'click', function () {
                    menu.removeVertex();
                });
            }
            DeleteMenu.prototype = new google.maps.OverlayView();
            DeleteMenu.prototype.onAdd = function () {
                var deleteMenu = this;
                var map = this.getMap();
                this.getPanes().floatPane.appendChild(this.div_);
                // mousedown anywhere on the map except on the menu div will close the
                // menu.
                this.divListener_ = google.maps.event.addDomListener(map.getDiv(), 'mousedown', function (e) {
                    if (e.target !== deleteMenu.div_) {
                        deleteMenu.close();
                    }
                }, true);
            };
            DeleteMenu.prototype.onRemove = function () {
                google.maps.event.removeListener(this.divListener_);
                this.div_.parentNode.removeChild(this.div_);
                // clean up
                this.set('position');
                this.set('path');
                this.set('vertex');
            };
            DeleteMenu.prototype.close = function () {
                this.setMap(null);
            };
            DeleteMenu.prototype.draw = function () {
                var position = this.get('position');
                var projection = this.getProjection();
                if (!position || !projection) {
                    return;
                }
                var point = projection.fromLatLngToDivPixel(position);
                this.div_.style.top = point.y + 'px';
                this.div_.style.left = point.x + 'px';
            };
            /**
             * Opens the menu at a vertex of a given path.
             */
            DeleteMenu.prototype.open = function (map, path, vertex) {
                this.set('position', path.getAt(vertex));
                this.set('path', path);
                this.set('vertex', vertex);
                this.setMap(map);
                this.draw();
            };
            DeleteMenu.prototype.removeVertex = function () {
                var path = this.get('path');
                var vertex = this.get('vertex');
                if (!path || vertex === undefined) {
                    this.close();
                    return;
                }
                path.removeAt(vertex);
                this.close();
            };
            return new DeleteMenu();
        };
        __decorate([core_1.Input(), __metadata('design:type', Array)], GooPolyline.prototype, "path", void 0);
        __decorate([core_1.Output(), __metadata('design:type', core_1.EventEmitter)], GooPolyline.prototype, "pathChange", void 0);
        __decorate([core_1.Input(), __metadata('design:type', Object)], GooPolyline.prototype, "options", void 0);
        __decorate([core_1.Input(), __metadata('design:type', Boolean)], GooPolyline.prototype, "editable", void 0);
        __decorate([core_1.Input(), __metadata('design:type', String)], GooPolyline.prototype, "strokeColor", void 0);
        GooPolyline = __decorate([core_1.Directive({
            selector: 'goo-polyline'
        }), __metadata('design:paramtypes', [goo_maps_api_service_1.GooMapsApiService])], GooPolyline);
        return GooPolyline;
    }();
    exports.GooPolyline = GooPolyline;
    

    return module.exports;
});
System.registerDynamic("src/goo-info-window/goo-info-window.component", ["@angular/core", "../service/goo-maps-api.service"], true, function ($__require, exports, module) {
    "use strict";

    var define,
        global = this || self,
        GLOBAL = global;
    var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
        var c = arguments.length,
            r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
            d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __metadata = this && this.__metadata || function (k, v) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
    };
    var core_1 = $__require("@angular/core");
    var goo_maps_api_service_1 = $__require("../service/goo-maps-api.service");
    var GooInfoWindow = function () {
        function GooInfoWindow(gooMapsApi, elementRef) {
            var _this = this;
            this.gooMapsApi = gooMapsApi;
            this.elementRef = elementRef;
            this.isOpen = false;
            this.promiseInfoWindow = new Promise(function (resolve) {
                _this.gooMapsApi.buildInfoWindow().then(function (infoWindow) {
                    resolve(infoWindow);
                });
            });
        }
        GooInfoWindow.prototype.ngOnChanges = function (changes) {
            if (changes['isOpen']) {
                this.isOpen ? this.open() : this.close();
            }
        };
        GooInfoWindow.prototype.ngOnInit = function () {
            var _this = this;
            var contentNode = this.elementRef.nativeElement.querySelector('.goo-info-window-content');
            this.content = contentNode.innerHTML;
            this.elementRef.nativeElement.removeChild(contentNode);
            this.promiseInfoWindow.then(function (infoWindow) {
                infoWindow.setContent(_this.content);
            });
        };
        GooInfoWindow.prototype.setMarker = function (marker) {
            this.marker = marker;
        };
        GooInfoWindow.prototype.open = function () {
            var _this = this;
            this.promiseInfoWindow.then(function (infoWindow) {
                infoWindow.open(_this.marker.getMap(), _this.marker);
            });
        };
        GooInfoWindow.prototype.close = function () {
            this.promiseInfoWindow.then(function (infoWindow) {
                infoWindow.close();
            });
        };
        __decorate([core_1.Input(), __metadata('design:type', Boolean)], GooInfoWindow.prototype, "isOpen", void 0);
        GooInfoWindow = __decorate([core_1.Component({
            selector: 'goo-info-window',
            template: '<div class="goo-info-window-content"><ng-content></ng-content></div>'
        }), __metadata('design:paramtypes', [goo_maps_api_service_1.GooMapsApiService, core_1.ElementRef])], GooInfoWindow);
        return GooInfoWindow;
    }();
    exports.GooInfoWindow = GooInfoWindow;
    

    return module.exports;
});
System.registerDynamic("src/goo-maps.module", ["@angular/core", "./service/goo-maps-loader.service", "./goo-map/goo-map.component", "./goo-marker/goo-marker.directive", "./goo-rectangle/goo-rectangle.directive", "./goo-polyline/goo-polyline.directive", "./goo-info-window/goo-info-window.component"], true, function ($__require, exports, module) {
    "use strict";

    var define,
        global = this || self,
        GLOBAL = global;
    var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
        var c = arguments.length,
            r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
            d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __metadata = this && this.__metadata || function (k, v) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
    };
    var core_1 = $__require("@angular/core");
    var goo_maps_loader_service_1 = $__require("./service/goo-maps-loader.service");
    var goo_map_component_1 = $__require("./goo-map/goo-map.component");
    var goo_marker_directive_1 = $__require("./goo-marker/goo-marker.directive");
    var goo_rectangle_directive_1 = $__require("./goo-rectangle/goo-rectangle.directive");
    var goo_polyline_directive_1 = $__require("./goo-polyline/goo-polyline.directive");
    var goo_info_window_component_1 = $__require("./goo-info-window/goo-info-window.component");
    var GooMapsModule = function () {
        function GooMapsModule() {}
        GooMapsModule = __decorate([core_1.NgModule({
            imports: [],
            exports: [goo_map_component_1.GooMap, goo_rectangle_directive_1.GooRectangle, goo_marker_directive_1.GooMarker, goo_polyline_directive_1.GooPolyline, goo_info_window_component_1.GooInfoWindow],
            declarations: [goo_map_component_1.GooMap, goo_rectangle_directive_1.GooRectangle, goo_marker_directive_1.GooMarker, goo_polyline_directive_1.GooPolyline, goo_info_window_component_1.GooInfoWindow],
            providers: [goo_maps_loader_service_1.GoogleMapsLoader]
        }), __metadata('design:paramtypes', [])], GooMapsModule);
        return GooMapsModule;
    }();
    exports.GooMapsModule = GooMapsModule;
    

    return module.exports;
});
System.registerDynamic("src/service/goo-maps-loader.service", ["@angular/core", "@angular/http"], true, function ($__require, exports, module) {
    "use strict";

    var define,
        global = this || self,
        GLOBAL = global;
    var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
        var c = arguments.length,
            r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
            d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __metadata = this && this.__metadata || function (k, v) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
    };
    var core_1 = $__require("@angular/core");
    var http_1 = $__require("@angular/http");
    var API_KEY = 'AIzaSyAEpfZd_HFg2kO58HP6L60EO_dpW1v8EeE';
    var url = 'https://maps.googleapis.com/maps/api/js?key=' + API_KEY + '&callback=initMap';
    var GoogleMapsLoader = function () {
        function GoogleMapsLoader(http) {
            var _this = this;
            this.http = http;
            this.loadMap = new Promise(function (resolve) {
                window['initMap'] = function () {
                    resolve();
                };
                _this.loadScript();
            });
        }
        GoogleMapsLoader.prototype.initMap = function () {
            return this.loadMap;
        };
        GoogleMapsLoader.prototype.loadScript = function () {
            var script = document.createElement('script');
            script.src = url;
            script.type = 'text/javascript';
            if (document.body.contains(script)) {
                return;
            }
            document.getElementsByTagName('head')[0].appendChild(script);
        };
        GoogleMapsLoader = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [http_1.Http])], GoogleMapsLoader);
        return GoogleMapsLoader;
    }();
    exports.GoogleMapsLoader = GoogleMapsLoader;
    

    return module.exports;
});
System.registerDynamic("src/service/goo-maps-api.service", ["@angular/core", "./goo-maps-loader.service"], true, function ($__require, exports, module) {
    "use strict";

    var define,
        global = this || self,
        GLOBAL = global;
    var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
        var c = arguments.length,
            r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
            d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __metadata = this && this.__metadata || function (k, v) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
    };
    var core_1 = $__require("@angular/core");
    var goo_maps_loader_service_1 = $__require("./goo-maps-loader.service");
    var GooMapsApiService = function () {
        function GooMapsApiService(googleMapsApi) {
            var _this = this;
            this.googleMapsApi = googleMapsApi;
            this.zeroLatLng = { lat: 0, lng: 0 };
            this.zeroZoom = 4;
            this.promiseMap = new Promise(function (resolve) {
                _this._promiseMapResolver = resolve;
            });
        }
        GooMapsApiService.prototype.init = function (mapId, mapOptions) {
            var _this = this;
            this.googleMapsApi.initMap().then(function () {
                // possibility that DOM element won't exist yet...?
                var map = new google.maps.Map(document.getElementById(mapId), {
                    center: _this.zeroLatLng,
                    zoom: _this.zeroZoom
                });
                map.setOptions(mapOptions);
                _this._promiseMapResolver(map);
            });
        };
        GooMapsApiService.prototype.setMapOptions = function (options) {
            this.getMap().then(function (map) {
                map.setOptions(options);
            });
        };
        GooMapsApiService.prototype.fitMapBounds = function (bounds) {
            if (!bounds) {
                return;
            }
            this.getMap().then(function (map) {
                map.fitBounds(bounds);
            });
        };
        GooMapsApiService.prototype.setCenter = function (latLng) {
            this.getMap().then(function (map) {
                map.setCenter(latLng);
            });
        };
        GooMapsApiService.prototype.getMap = function () {
            return this.promiseMap;
        };
        GooMapsApiService.prototype.buildMarker = function (options) {
            var _this = this;
            return new Promise(function (resolve) {
                _this.promiseMap.then(function (map) {
                    var marker = new google.maps.Marker({
                        position: new google.maps.LatLng(options.position.lat, options.position.lng),
                        map: map,
                        title: options.title
                    });
                    resolve(marker);
                });
            });
        };
        GooMapsApiService.prototype.buildPolyline = function (options) {
            var _this = this;
            return new Promise(function (resolve) {
                _this.promiseMap.then(function (map) {
                    var polyline = new google.maps.Polyline({
                        path: [],
                        geodesic: true,
                        strokeColor: '#FF0000',
                        strokeOpacity: 1.0,
                        strokeWeight: 2,
                        map: map
                    });
                    resolve(polyline);
                });
            });
        };
        GooMapsApiService.prototype.buildRectangle = function (options) {
            var _this = this;
            return new Promise(function (resolve) {
                _this.promiseMap.then(function (map) {
                    var rectangle = new google.maps.Rectangle({
                        strokeColor: '#FF0000',
                        strokeOpacity: 0.8,
                        strokeWeight: 2,
                        fillColor: '#FF0000',
                        fillOpacity: 0.35,
                        map: map
                    });
                    resolve(rectangle);
                });
            });
        };
        GooMapsApiService.prototype.buildInfoWindow = function (options) {
            var _this = this;
            return new Promise(function (resolve) {
                _this.promiseMap.then(function (map) {
                    if (!options) {
                        options = { content: '' };
                    }
                    resolve(new google.maps.InfoWindow(options));
                });
            });
        };
        GooMapsApiService = __decorate([core_1.Injectable(), __metadata('design:paramtypes', [goo_maps_loader_service_1.GoogleMapsLoader])], GooMapsApiService);
        return GooMapsApiService;
    }();
    exports.GooMapsApiService = GooMapsApiService;
    

    return module.exports;
});
System.registerDynamic('ng2-goo-maps', ['./src/goo-maps.module', './src/service/goo-maps-api.service'], true, function ($__require, exports, module) {
    "use strict";

    var define,
        global = this || self,
        GLOBAL = global;
    function __export(m) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }
    __export($__require('./src/goo-maps.module'));
    __export($__require('./src/service/goo-maps-api.service'));
    

    return module.exports;
});