"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var goo_maps_api_service_1 = require('../service/goo-maps-api.service');
var GooInfoWindow = (function () {
    function GooInfoWindow(gooMapsApi, elementRef) {
        var _this = this;
        this.gooMapsApi = gooMapsApi;
        this.elementRef = elementRef;
        this.isOpen = false;
        this.promiseInfoWindow = new Promise(function (resolve) {
            _this.gooMapsApi.buildInfoWindow().then(function (infoWindow) {
                resolve(infoWindow);
            });
        });
    }
    GooInfoWindow.prototype.ngOnChanges = function (changes) {
        if (changes['isOpen']) {
            this.isOpen ? this.open() : this.close();
        }
    };
    GooInfoWindow.prototype.ngOnInit = function () {
        var _this = this;
        var contentNode = this.elementRef.nativeElement.querySelector('.goo-info-window-content');
        this.content = contentNode.innerHTML;
        this.elementRef.nativeElement.removeChild(contentNode);
        this.promiseInfoWindow.then(function (infoWindow) {
            infoWindow.setContent(_this.content);
        });
    };
    GooInfoWindow.prototype.setMarker = function (marker) {
        this.marker = marker;
    };
    GooInfoWindow.prototype.open = function () {
        var _this = this;
        this.promiseInfoWindow.then(function (infoWindow) {
            infoWindow.open(_this.marker.getMap(), _this.marker);
        });
    };
    GooInfoWindow.prototype.close = function () {
        this.promiseInfoWindow.then(function (infoWindow) {
            infoWindow.close();
        });
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GooInfoWindow.prototype, "isOpen", void 0);
    GooInfoWindow = __decorate([
        core_1.Component({
            selector: 'goo-info-window',
            template: '<div class="goo-info-window-content"><ng-content></ng-content></div>'
        }), 
        __metadata('design:paramtypes', [goo_maps_api_service_1.GooMapsApiService, core_1.ElementRef])
    ], GooInfoWindow);
    return GooInfoWindow;
}());
exports.GooInfoWindow = GooInfoWindow;
//# sourceMappingURL=goo-info-window.component.js.map