"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var goo_maps_api_service_1 = require('../service/goo-maps-api.service');
var GOO_MAPS_ID = {
    currentId: 1
};
var GooMap = (function () {
    function GooMap(gooMapsApi) {
        this.gooMapsApi = gooMapsApi;
        this.mapId = 'map_' + GOO_MAPS_ID.currentId++;
    }
    GooMap.prototype.ngOnChanges = function (changes) {
        if (changes['options']) {
            this.gooMapsApi.setMapOptions(this.options);
        }
        if (changes['bounds']) {
            this.gooMapsApi.fitMapBounds(this.bounds);
        }
        if (changes['center']) {
            this.gooMapsApi.setCenter(this.center);
        }
    };
    GooMap.prototype.ngOnInit = function () {
        this.gooMapsApi.init(this.mapId, this.options);
    };
    __decorate([
        core_1.Input('height'), 
        __metadata('design:type', Number)
    ], GooMap.prototype, "mapHeight", void 0);
    __decorate([
        core_1.Input('options'), 
        __metadata('design:type', Object)
    ], GooMap.prototype, "options", void 0);
    __decorate([
        core_1.Input('mapId'), 
        __metadata('design:type', String)
    ], GooMap.prototype, "mapId", void 0);
    __decorate([
        core_1.Input('bounds'), 
        __metadata('design:type', Object)
    ], GooMap.prototype, "bounds", void 0);
    __decorate([
        core_1.Input('center'), 
        __metadata('design:type', Object)
    ], GooMap.prototype, "center", void 0);
    __decorate([
        core_1.Input('styleClass'), 
        __metadata('design:type', String)
    ], GooMap.prototype, "styleClass", void 0);
    GooMap = __decorate([
        core_1.Component({
            selector: 'goo-map',
            template: '<div class="goo-map {{styleClass}}" id="{{mapId}}" [style.height]="mapHeight?mapHeight + \'px\':\'\'"></div><div id="map-content"><ng-content></ng-content></div>'
        }), 
        __metadata('design:paramtypes', [goo_maps_api_service_1.GooMapsApiService])
    ], GooMap);
    return GooMap;
}());
exports.GooMap = GooMap;
//# sourceMappingURL=goo-map.component.js.map