"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var goo_maps_api_service_1 = require('../service/goo-maps-api.service');
var goo_info_window_component_1 = require('../goo-info-window/goo-info-window.component');
var GooMarker = (function () {
    function GooMarker(gooMapsApi) {
        var _this = this;
        this.gooMapsApi = gooMapsApi;
        this.positionChange = new core_1.EventEmitter();
        var self = this;
        this.position = { lat: 0, lng: 0 };
        this.title = '';
        this.promiseMarker = new Promise(function (resolve) {
            _this.gooMapsApi.buildMarker({
                position: _this.position,
                title: _this.title
            }).then(function (marker) {
                marker.addListener('dragend', function () {
                    self.onPositionChange({ lat: marker.getPosition().lat(), lng: marker.getPosition().lng() });
                });
                resolve(marker);
            });
        });
    }
    GooMarker.prototype.ngOnChanges = function (changes) {
        if (changes['draggable']) {
            this.setDraggable(this.draggable);
        }
        if (changes['position']) {
            this.setPosition(this.position);
        }
        if (changes['title']) {
            this.setTitle(this.title);
        }
        if (changes['label']) {
            this.setLabel(this.label);
        }
    };
    GooMarker.prototype.ngOnInit = function () {
        var _this = this;
        this.promiseMarker.then(function (marker) {
            marker.setPosition(_this.position);
            marker.setTitle(_this.title);
            if (_this.infoWindow !== undefined && _this.infoWindow) {
                _this.infoWindow.setMarker(marker);
            }
        });
    };
    GooMarker.prototype.ngOnDestroy = function () {
        this.promiseMarker.then(function (marker) { return marker.setMap(null); });
    };
    GooMarker.prototype.onPositionChange = function (position) {
        this.position = position;
        this.positionChange.emit(this.position);
    };
    GooMarker.prototype.setDraggable = function (draggable) {
        this.promiseMarker.then(function (marker) {
            marker.setDraggable(draggable);
        });
    };
    GooMarker.prototype.setPosition = function (position) {
        this.promiseMarker.then(function (marker) {
            marker.setPosition(position);
        });
    };
    GooMarker.prototype.setTitle = function (title) {
        this.promiseMarker.then(function (marker) {
            marker.setTitle(title);
        });
    };
    GooMarker.prototype.setLabel = function (label) {
        this.promiseMarker.then(function (marker) {
            marker.setLabel(label);
        });
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], GooMarker.prototype, "position", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], GooMarker.prototype, "positionChange", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GooMarker.prototype, "title", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GooMarker.prototype, "draggable", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GooMarker.prototype, "label", void 0);
    __decorate([
        core_1.ContentChild(goo_info_window_component_1.GooInfoWindow), 
        __metadata('design:type', goo_info_window_component_1.GooInfoWindow)
    ], GooMarker.prototype, "infoWindow", void 0);
    GooMarker = __decorate([
        core_1.Directive({
            selector: 'goo-marker'
        }), 
        __metadata('design:paramtypes', [goo_maps_api_service_1.GooMapsApiService])
    ], GooMarker);
    return GooMarker;
}());
exports.GooMarker = GooMarker;
//# sourceMappingURL=goo-marker.directive.js.map