import { OnInit, OnDestroy, OnChanges, SimpleChange, EventEmitter } from '@angular/core';
import { GooMapsApiService } from '../service/goo-maps-api.service';
import { LatLng, PolylineOptions } from '../interface/definitions';
export declare class GooPolyline implements OnInit, OnChanges, OnDestroy {
    private gooMapsApi;
    path: Array<LatLng>;
    pathChange: EventEmitter<any>;
    options: PolylineOptions;
    editable: boolean;
    strokeColor: string;
    private promisePolyline;
    constructor(gooMapsApi: GooMapsApiService);
    ngOnChanges(changes: {
        [propertyName: string]: SimpleChange;
    }): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    pathChangedCallback: () => void;
    onChangePath(event: any): void;
    setEditable(editable: boolean): void;
    setStrokeColor(color: string): void;
    setPath(path: Array<LatLng>): void;
    private buildDeleteMenu();
}
