"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var goo_maps_api_service_1 = require('../service/goo-maps-api.service');
var GooPolyline = (function () {
    function GooPolyline(gooMapsApi) {
        var _this = this;
        this.gooMapsApi = gooMapsApi;
        this.pathChange = new core_1.EventEmitter();
        this.strokeColor = '#FF0000';
        this.pathChangedCallback = function () {
            _this.promisePolyline.then(function (polyline) {
                var path = polyline.getPath().getArray();
                _this.onChangePath(path);
            });
        };
        var self = this;
        this.promisePolyline = new Promise(function (resolve) {
            _this.gooMapsApi.buildPolyline({}).then(function (polyline) {
                google.maps.event.addListener(polyline, 'rightclick', function (e) {
                    if (e.vertex === undefined) {
                        return;
                    }
                    self.buildDeleteMenu().open(polyline.getMap(), polyline.getPath(), e.vertex);
                });
                resolve(polyline);
            });
        });
    }
    GooPolyline.prototype.ngOnChanges = function (changes) {
        if (changes['editable']) {
            this.setEditable(this.editable);
        }
        if (changes['path']) {
            this.setPath(this.path);
        }
        if (changes['strokeColor']) {
            this.setStrokeColor(this.strokeColor);
        }
    };
    GooPolyline.prototype.ngOnInit = function () {
        var _this = this;
        this.promisePolyline.then(function (polyline) {
            polyline.setPath(_this.path);
            polyline.setOptions(_this.options);
        });
    };
    GooPolyline.prototype.ngOnDestroy = function () {
        this.promisePolyline.then(function (polyline) { return polyline.setMap(null); });
    };
    GooPolyline.prototype.onChangePath = function (event) {
        this.path = event;
        this.pathChange.emit(event);
    };
    GooPolyline.prototype.setEditable = function (editable) {
        this.promisePolyline.then(function (polyline) {
            polyline.setEditable(editable);
        });
    };
    GooPolyline.prototype.setStrokeColor = function (color) {
        this.promisePolyline.then(function (polyline) {
            polyline.setOptions({
                strokeColor: color
            });
        });
    };
    GooPolyline.prototype.setPath = function (path) {
        var self = this;
        this.promisePolyline.then(function (polyline) {
            polyline.setPath(path);
            google.maps.event.addListener(polyline.getPath(), 'insert_at', self.pathChangedCallback);
            google.maps.event.addListener(polyline.getPath(), 'remove_at', self.pathChangedCallback);
            google.maps.event.addListener(polyline.getPath(), 'set_at', self.pathChangedCallback);
        });
    };
    GooPolyline.prototype.buildDeleteMenu = function () {
        function DeleteMenu() {
            this.div_ = document.createElement('div');
            this.div_.className = 'delete-menu';
            this.div_.innerHTML = 'Delete';
            this.div_.style.cssText = 'position:absolute;background:white;padding:3px;color:#666;font-weight:bold;'
                + 'border:1pxsolid#999;font-family:sans-serif;font-size:12px;box-shadow:1px3px3pxrgba(0,0,0,.3);'
                + 'margin-top:-10px;margin-left:10px;cursor:pointer;';
            var menu = this;
            google.maps.event.addDomListener(this.div_, 'click', function () {
                menu.removeVertex();
            });
        }
        DeleteMenu.prototype = new google.maps.OverlayView();
        DeleteMenu.prototype.onAdd = function () {
            var deleteMenu = this;
            var map = this.getMap();
            this.getPanes().floatPane.appendChild(this.div_);
            // mousedown anywhere on the map except on the menu div will close the
            // menu.
            this.divListener_ = google.maps.event.addDomListener(map.getDiv(), 'mousedown', function (e) {
                if (e.target !== deleteMenu.div_) {
                    deleteMenu.close();
                }
            }, true);
        };
        DeleteMenu.prototype.onRemove = function () {
            google.maps.event.removeListener(this.divListener_);
            this.div_.parentNode.removeChild(this.div_);
            // clean up
            this.set('position');
            this.set('path');
            this.set('vertex');
        };
        DeleteMenu.prototype.close = function () {
            this.setMap(null);
        };
        DeleteMenu.prototype.draw = function () {
            var position = this.get('position');
            var projection = this.getProjection();
            if (!position || !projection) {
                return;
            }
            var point = projection.fromLatLngToDivPixel(position);
            this.div_.style.top = point.y + 'px';
            this.div_.style.left = point.x + 'px';
        };
        /**
         * Opens the menu at a vertex of a given path.
         */
        DeleteMenu.prototype.open = function (map, path, vertex) {
            this.set('position', path.getAt(vertex));
            this.set('path', path);
            this.set('vertex', vertex);
            this.setMap(map);
            this.draw();
        };
        DeleteMenu.prototype.removeVertex = function () {
            var path = this.get('path');
            var vertex = this.get('vertex');
            if (!path || vertex === undefined) {
                this.close();
                return;
            }
            path.removeAt(vertex);
            this.close();
        };
        return new DeleteMenu();
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], GooPolyline.prototype, "path", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], GooPolyline.prototype, "pathChange", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], GooPolyline.prototype, "options", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GooPolyline.prototype, "editable", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], GooPolyline.prototype, "strokeColor", void 0);
    GooPolyline = __decorate([
        core_1.Directive({
            selector: 'goo-polyline'
        }), 
        __metadata('design:paramtypes', [goo_maps_api_service_1.GooMapsApiService])
    ], GooPolyline);
    return GooPolyline;
}());
exports.GooPolyline = GooPolyline;
//# sourceMappingURL=goo-polyline.directive.js.map