"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var goo_maps_api_service_1 = require('../service/goo-maps-api.service');
var GooRectangle = (function () {
    function GooRectangle(gooMapsApi) {
        var _this = this;
        this.gooMapsApi = gooMapsApi;
        this.boundsChanged = new core_1.EventEmitter();
        this.draggable = false;
        this.editable = false;
        var self = this;
        this.promiseRectangle = new Promise(function (resolve) {
            _this.gooMapsApi.buildRectangle({}).then(function (rectangle) {
                rectangle.addListener('dragend', function () {
                    var bounds = rectangle.getBounds();
                    self.onBoundsChanged({
                        north: bounds.getNorthEast().lat(),
                        south: bounds.getSouthWest().lat(),
                        east: bounds.getNorthEast().lng(),
                        west: bounds.getSouthWest().lng()
                    });
                });
                resolve(rectangle);
            });
        });
    }
    GooRectangle.prototype.ngOnChanges = function (changes) {
        var self = this;
        if (changes['draggable']) {
            this.promiseRectangle.then(function (rectangle) {
                rectangle.setDraggable(self.draggable ? true : false);
            });
        }
        if (changes['editable']) {
            this.promiseRectangle.then(function (rectangle) {
                rectangle.setEditable(self.editable ? true : false);
            });
        }
        // if (changes['bounds']) {
        //   this.promiseRectangle.then(function (rectangle) {
        //     rectangle.setBounds(self.bounds);
        //   });
        // } // CAUSES AN EVENT LOOP (TODO)
    };
    GooRectangle.prototype.ngOnInit = function () {
        var _this = this;
        this.promiseRectangle.then(function (rectangle) {
            rectangle.setBounds(_this.bounds);
            rectangle.setDraggable(_this.draggable);
            rectangle.setEditable(_this.editable);
        });
    };
    GooRectangle.prototype.ngOnDestroy = function () {
        this.promiseRectangle.then(function (rectangle) { return rectangle.setMap(null); });
    };
    GooRectangle.prototype.onBoundsChanged = function (bounds) {
        this.bounds = bounds;
        this.boundsChanged.emit(bounds);
    };
    __decorate([
        core_1.Input('bounds'), 
        __metadata('design:type', Object)
    ], GooRectangle.prototype, "bounds", void 0);
    __decorate([
        core_1.Output('boundsChanged'), 
        __metadata('design:type', core_1.EventEmitter)
    ], GooRectangle.prototype, "boundsChanged", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GooRectangle.prototype, "draggable", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], GooRectangle.prototype, "editable", void 0);
    GooRectangle = __decorate([
        core_1.Directive({
            selector: 'goo-rectangle'
        }), 
        __metadata('design:paramtypes', [goo_maps_api_service_1.GooMapsApiService])
    ], GooRectangle);
    return GooRectangle;
}());
exports.GooRectangle = GooRectangle;
//# sourceMappingURL=goo-rectangle.directive.js.map