"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var goo_maps_loader_service_1 = require('./goo-maps-loader.service');
var GooMapsApiService = (function () {
    function GooMapsApiService(googleMapsApi) {
        var _this = this;
        this.googleMapsApi = googleMapsApi;
        this.zeroLatLng = { lat: 0, lng: 0 };
        this.zeroZoom = 4;
        this.promiseMap = new Promise(function (resolve) {
            _this._promiseMapResolver = resolve;
        });
    }
    GooMapsApiService.prototype.init = function (mapId, mapOptions) {
        var _this = this;
        this.googleMapsApi.initMap().then(function () {
            // possibility that DOM element won't exist yet...?
            var map = new google.maps.Map(document.getElementById(mapId), {
                center: _this.zeroLatLng,
                zoom: _this.zeroZoom
            });
            map.setOptions(mapOptions);
            _this._promiseMapResolver(map);
        });
    };
    GooMapsApiService.prototype.setMapOptions = function (options) {
        this.getMap().then(function (map) {
            map.setOptions(options);
        });
    };
    GooMapsApiService.prototype.fitMapBounds = function (bounds) {
        if (!bounds) {
            return;
        }
        this.getMap().then(function (map) {
            map.fitBounds(bounds);
        });
    };
    GooMapsApiService.prototype.setCenter = function (latLng) {
        this.getMap().then(function (map) {
            map.setCenter(latLng);
        });
    };
    GooMapsApiService.prototype.getMap = function () {
        return this.promiseMap;
    };
    GooMapsApiService.prototype.buildMarker = function (options) {
        var _this = this;
        return new Promise(function (resolve) {
            _this.promiseMap.then(function (map) {
                var marker = new google.maps.Marker({
                    position: new google.maps.LatLng(options.position.lat, options.position.lng),
                    map: map,
                    title: options.title
                });
                resolve(marker);
            });
        });
    };
    GooMapsApiService.prototype.buildPolyline = function (options) {
        var _this = this;
        return new Promise(function (resolve) {
            _this.promiseMap.then(function (map) {
                var polyline = new google.maps.Polyline({
                    path: [],
                    geodesic: true,
                    strokeColor: '#FF0000',
                    strokeOpacity: 1.0,
                    strokeWeight: 2,
                    map: map
                });
                resolve(polyline);
            });
        });
    };
    GooMapsApiService.prototype.buildRectangle = function (options) {
        var _this = this;
        return new Promise(function (resolve) {
            _this.promiseMap.then(function (map) {
                var rectangle = new google.maps.Rectangle({
                    strokeColor: '#FF0000',
                    strokeOpacity: 0.8,
                    strokeWeight: 2,
                    fillColor: '#FF0000',
                    fillOpacity: 0.35,
                    map: map
                });
                resolve(rectangle);
            });
        });
    };
    GooMapsApiService.prototype.buildInfoWindow = function (options) {
        var _this = this;
        return new Promise(function (resolve) {
            _this.promiseMap.then(function (map) {
                if (!options) {
                    options = { content: '' };
                }
                resolve(new google.maps.InfoWindow(options));
            });
        });
    };
    GooMapsApiService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [goo_maps_loader_service_1.GoogleMapsLoader])
    ], GooMapsApiService);
    return GooMapsApiService;
}());
exports.GooMapsApiService = GooMapsApiService;
//# sourceMappingURL=goo-maps-api.service.js.map